//+------------------------------------------------------------------+
//|                                   JoeChalhoub_FXForecasterV1.mq4 |
//|                                                  www.rpchost.com |
//|                                            webmaster@rpchost.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Rpchost.com"
#property link      "webmaster@rpchost.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Violet
#property indicator_color2 Gray
#property indicator_level1 0


double Value=0,Value1=0,Value2=0,Fish=0,Fish1=0,Fish2=0;
int buy=0,sell=0;

double buffer1[];
double buffer2[];
double buffer3[];
double MA1buffer[];
double MA2buffer[];

extern int period=10;
extern int price=0;

extern int MA1period=13, MA2period=45;
extern int TypeMA1=0;
extern int TypeMA2=0;


double upMA[];
double downMA[];

double MA[];
double MA2[];

int init(){
   IndicatorBuffers(3);
   
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 1);
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 1);
 
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(0,MA1buffer);
   SetIndexBuffer(1,MA2buffer);
}

int start(){
    int counted_bars=IndicatorCounted();

   if(counted_bars < 0){
       counted_bars = 0;
   }
   if(counted_bars>0) counted_bars--;
   int i;
   int barras;
   double _price;
   double tmp;
   double MinL=0;
   double MaxH=0;
   double Threshold=1.2;

   

   barras=Bars-counted_bars;
    for(i=0; i<barras; i++) {
      switch(price){
         case 1: _price=Open[i]; 
         break;
         case 2: _price=Close[i]; 
         break;
         case 3: _price=High[i]; 
         break;
         case 4: _price=Low[i]; 
         break;
         case 5: _price=(High[i]+Low[i]+Close[i])/3; 
         break;
         case 6: _price=(Open[i]+High[i]+Low[i]+Close[i])/4; 
         break;
         case 7: _price=(Open[i]+Close[i])/2; 
         break;
         default: _price=(High[i]+Low[i])/2; 
         break;
      }
      MaxH=High[Highest(NULL, 0 ,MODE_HIGH, period, i)];
      MinL=Low[Lowest(NULL, 0 ,MODE_LOW, period, i)];
      Value=0.33*2*((_price-MinL)/(MaxH-MinL)-0.5) + 0.67*Value1;
      Value=MathMin(MathMax(Value,-0.999),0.999);
      Fish=0.5*MathLog((1+Value)/(1-Value))+0.5*Fish1;
      buffer1[i]= 0;
      buffer2[i]= 0;

      if((Fish<0) && (Fish1>0)){
         buy=0;
      }
      if ((Fish>0) && (Fish1<0)){
         sell=0;
      }
      if (Fish>=0){
         buffer3[i]= Fish;
      }else{
         buffer3[i]= Fish;
      }
      Value1=Value;
      Fish2=Fish1;
      Fish1=Fish;
   }
   for(i=0; i<barras; i++) {
      MA1buffer[i]=iMAOnArray(buffer3,Bars,MA1period,0,TypeMA1,i);
   }
   for(i=0; i<barras; i++) {
      MA2buffer[i]=iMAOnArray(MA1buffer,Bars,MA2period,0,TypeMA2,i);
   }
}